<template>
    <div v-if="innerValueCurrentOffice">
        <v-card elevation="1" class="admin-content pa-4">
            <v-btn
                color="primary"
                @click="$router.go(-1)"
                class="mb-4"
            >
                <v-icon left>mdi-keyboard-backspace</v-icon>
                    Retour
                </v-btn>
            <div class="text-h4">Détail cabinet</div>
            <v-form
                ref="form"
                v-model="isFormValid"
                @submit.prevent="submitUpdatedForm"
            >
                <div class="text-h6 mt-6">Informations générales</div>
                <v-row>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentOffice.name"
                            :rules="[$utils.rules.required]"
                            :counter="32"
                            label="Nom du cabinet"
                            required
                            clearable
                        />
                    </v-col>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentOffice.label"
                            :rules="[$utils.rules.required]"
                            :counter="94"
                            label="Label"
                            required
                            clearable
                        />
                    </v-col>
                   <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentOffice.phoneNumber"
                            :rules="[$utils.rules.required]"
                            :counter="10"
                            label="Numéro de téléphone"
                            required
                            clearable
                        />
                    </v-col>
                </v-row>
                <v-row>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentOffice.faxNumber"
                            :counter="10"
                            label="Numéro de fax"
                            required
                            clearable
                        />
                    </v-col>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentOffice.email"
                            :rules="[$utils.rules.required, $utils.rules.email]"
                            label="E-mail"
                            :counter="64"
                            required
                            clearable
                        />
                    </v-col>
                    <v-col cols="12" sm="4">
                        <v-select
                            v-model="innerValueCurrentOffice.status"
                            :items="statusSelectItems"
                            label="Statut"
                        ></v-select>
                    </v-col>
                </v-row>
                <v-row>
                    <v-col cols="12">
                        <v-textarea
                            v-model="innerValueCurrentOffice.description"
                            label="Description"
                            clearable
                            color="teal"
                        />
                    </v-col>
                </v-row>
                <div class="text-h6 mt-6">Adresse complète</div>
                <v-row>
                    <v-col cols="12" md="12">
                        <v-text-field
                            v-model="innerValueCurrentOffice.address"
                            :rules="[$utils.rules.required]"
                            :counter="94"
                            label="Adresse"
                            required
                            clearable
                        />
                    </v-col>
                </v-row>
                <v-row>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentOffice.postalCode"
                            :rules="[$utils.rules.required]"
                            :counter="8"
                            label="Code postale"
                            required
                            clearable
                        />
                    </v-col>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentOffice.city"
                            :rules="[$utils.rules.required]"
                            :counter="64"
                            label="Ville"
                            required
                            clearable
                        />
                    </v-col>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentOffice.country"
                            :rules="[$utils.rules.required]"
                            :counter="32"
                            label="Pays"
                            required
                            clearable
                        />
                    </v-col>
                </v-row>
                <v-btn color="green" type="submit" dark :disabled="!isFormValid">
                    Enregistrer
                </v-btn>
            </v-form>
        </v-card>
        <Pros :prosOfOffice="innerValueCurrentOffice.pros" :title="`Professionnels du ${innerValueCurrentOffice.name}`" />
        <v-snackbar
            v-model="officeDetailSnackbar"
            :timeout="3000"
            :color="snackbarColor"
        >
            {{snackbarMessage}}
            <template v-slot:action="{ attrs }">
                <v-btn
                    color="white"
                    text
                    v-bind="attrs"
                    @click="officeDetailSnackbar = false"
                >
                    Fermer
                </v-btn>
            </template>
        </v-snackbar>
        <v-card elevation="1" class="admin-content pa-4">
          <div class="text-h5 mb-4">Débug</div>
          <p>{{ JSON.stringify(innerValueCurrentOffice) }}</p>
        </v-card>
    </div>
</template>

<script>
import Pros from '@/views/Admin/Pro/Pros';
import {mapActions, mapGetters} from 'vuex';

export default {
    name: 'OfficeDetail',
    components: {
        Pros,
    },
    data: () => ({
        innerValueCurrentOffice: null,
        isFormValid: true,
        officeDetailSnackbar: false,
        snackbarMessage: '',
        snackbarColor: '',
        statusSelectItems: [
            {text: 'Vérifié', value: 1},
            {text: 'En attente', value: 0},
            {text: 'Archivé', value: -1}
        ]
    }),
    methods: {
        ...mapActions(['loadOffice', 'updateOffice']),
        submitUpdatedForm() {
            let dataChanged = this.$utils.getChanges(this.getCurrentOffice, this.innerValueCurrentOffice);
            if (!this.$utils.isEmptyObject(dataChanged)) {
                dataChanged.id = this.innerValueCurrentOffice.id;
                this.updateOffice(dataChanged)
                    .then(() => {
                        this.snackbarMessage = 'Les données ont été sauvegardées';
                        this.snackbarColor = 'green';
                        this.officeDetailSnackbar = true;
                    })
                    .catch((error) => {
                        this.snackbarMessage = error;
                        this.snackbarColor = 'red';
                        this.officeDetailSnackbar = true;
                    });
            } else {
                this.snackbarMessage = 'Les données ont été sauvegardées';
                this.snackbarColor = 'green';
                this.officeDetailSnackbar = true;
            }
        }
    },
    computed: {
        ...mapGetters(['getCurrentOffice'])
    },
    async mounted() {
        await this.loadOffice(this.$route.params.officeId);
        this.innerValueCurrentOffice = Object.assign({}, this.getCurrentOffice);
    }
}
</script>

